//
// Author: Strelok Vlad Kolerts, (C) 2009
//
// 


#include "KString.h"

#include "tools/TextView.h"
//#include "tools/TextInput.h"

#include <ZApplication.h>
#include <RES_ICON_Reader.h>
#include <qcopchannel_qws.h>
#include <ZConfig.h>

#include <ZScrollPanel.h>
#include <qlabel.h>
#include <ZLabel.h>
#include <ZListBox.h>
#include <ZSeparator.h>
#include <ZMeter.h>
#include <ZSoftKey.h>

#include <qdatetime.h>
//#include <qwallpaper.h>
#include <qtextstream.h>
#include <pthread.h>
#include <stdlib.h>
#include <unistd.h>
#include <qdir.h>

#define TGZ_UNCPACK	"/bin/busybox tar xz -f %1 -C %2"
#define CARD_PATH	"/mmc/mmca1/.system/QTDownLoad/"
#define PHONE_PATH	"/ezxlocal/.system/QTDownLoad/"
#define CARD_DB		"/mmc/mmca1/.system/java/CardRegistry"
#define PHONE_DB	"/ezx_user/download/appwrite/am/InstalledDB"
#define MENU_DB		"/ezx_user/download/appwrite/am/UserMenuTree"
#define MAIN_MENU	"2a58c0d6-05c6-45aa-8938-63059d41a4e9"
/*#define CARD_DB	"/mmc/mmca1/test_db.txt"
#define PHONE_DB	"/mmc/mmca1/test_db.txt"*/

bool process=false;
ZMeter*		ProgressBar;

void* visProgress(void* )
{
	int i = 1;
	while(process)
	{
		ProgressBar->setProgress(i);
		i = (++i) % 26;
		usleep(10000);
	}
	return NULL;
}
/*
void* runCmd(void* p)
{
	if( cmd!= NULL )
	{
		system(cmd);
	}
	process=true;
	return NULL;
}*/

class Installer : public QWidget
{
	Q_OBJECT
	
	ZScrollPanel* panel;
	QLabel* 	Title;
	ZLabel* 	Label1;
	ZLabel* 	Label2;
	ZListBox*	Buttons;
	ZSeparator*	separator;
	ZSoftKey*	softKey;
	
	TextView*	textView;
	
	int InstallMode;
	
	QPixmap ItemPm[3][2];
	//QPixmap ItemPmUnEnable[2];
	bool chk[3];	//{RadioBtnToSD, RadioBtnToPhone, CheckBoxRootChown}
	QString ProgDir, work_folder;

	QString mpkgFile, destPath, QTDownLoad, Folder, BigIcon, Comment, Exec, GroupID, Icon, Name, Version, OsVersion, Type, InstalledDate;

	pthread_t vis;
	//pthread_t run;
public:

Installer() : QWidget(NULL, "Installer")
{
	setBackgroundMode(NoBackground);
	resize( 240, 320 );
	
	QFont font(NULL,16,25,false);
	setFont(font);
	
	textView = new TextView();

	ProgDir=getWorkDir(1);
	work_folder=getWorkDir(0);
	mpkgFile=UTF(qApp->argv()[2]);
	InstallMode=0;
	if (getMime(mpkgFile)=="fpg")
		InstallMode=1;

	Title = new QLabel(this);
	Title->setFixedWidth(240);
	QString text;
		text="<table width=\"240\" border=\"0\" cellspacing=\"0\" cellpadding=\"10\" bgcolor=\"#000000\"><tr><td align=\"center\">";
		text+="<img src="+ProgDir+"Installer.png width=\"48\" height=\"48\">";
		text+="</td><td width=\"175\" align=\"left\" >";
		text+="<font size=\"3\" color=\"#eeeeee\"><b>Installer 1.1</b></font><br><font size=\"2\" color=\"#eeeeee\">by Strelok Vlad Kolerts</font>";
		text+="</td></tr></table>";
	Title->setText(text);
	Title->move(0, 0);
	
	int t_h=Title->heightForWidth(240);
	Title->setFixedHeight(t_h);
	t_h=t_h-15;
	
	panel = new ZScrollPanel(this, "Installer", 0, (ZSkinService::WidgetClsID)4);
	panel->setVScrollBarMode(ZScrollPanel::AlwaysOff);
    panel->setHScrollBarMode(ZScrollPanel::AlwaysOff);
	panel->setFixedWidth(240);
	
	softKey = new ZSoftKey(0,this,this);
	softKey->setText(ZSoftKey::LEFT, "Yes", (ZSoftKey::TEXT_PRIORITY)0);
	softKey->setText(ZSoftKey::RIGHT, "No", (ZSoftKey::TEXT_PRIORITY)0);
	softKey->setClickedSlot(ZSoftKey::LEFT, this, SLOT(Install()));
	softKey->setClickedSlot(ZSoftKey::RIGHT, qApp, SLOT(quit()));
	int s_h=softKey->height()-10;
	softKey->setFixedWidth(240);
	softKey->move(0,320-s_h);
	
	panel->setFixedHeight(320-t_h-s_h);
	panel->move(0, t_h);
	
	//
	
	int h=0;
	Label1 = new ZLabel(QString("Do you realy want to install %1?").arg(kGetFile(qApp->argv()[2])), panel, "ZLabel", 0, (ZSkinService::WidgetClsID)4);
	Label1->setFixedWidth(226);
	Label1->setAutoResize( true );
	panel->moveChild(Label1,5,h);
	h+=Label1->heightForWidth(226);
	Label1->setFixedHeight(h);
	
	Buttons = new ZListBox(panel, 0, ZSkinService::clsZListBox1);
	Buttons->setFixedWidth(240);
	font=QFont(NULL,14,25,false);
	QFont font1(NULL,14,87,false);
	
	Buttons->setItemFont(ZListBox::region2, font, false);
	Buttons->setItemFont(ZListBox::region2, font1, true);
	
	textView->setFont(font);
	RES_ICON_Reader r;
	int b_h=h;
	
	if(InstallMode==0)
	{
		QString TextItem[3]={"to Memmory Stick", "to Phone", "root chown"};
		
		ItemPm[0][0]=ItemPm[1][0]=r.getIcon("radiobtn_mark_indicator_h.g");
		ItemPm[0][1]=ItemPm[1][1]=r.getIcon("radiobtn_mark_indicator_hs.g");
		ItemPm[2][0]=r.getIcon("chkbx_mark_indicator_h.g");
		ItemPm[2][1]=r.getIcon("chkbx_mark_indicator_hs.g");
		//ItemPmUnEnable[0]=r.getIcon("radiobtn_mark_indicator_ps.g");
		//ItemPmUnEnable[1]=r.getIcon("chkbx_mark_indicator_ps.g");
		
		chk[0]=true;
		chk[1]=chk[2]=false;
		for(int i=0; i<3; i++)
		{
			ZListBoxItem* Item = new ZListBoxItem ( Buttons, "%I%M" );
			Item->setPixmap ( 0, ItemPm[i][chk[i]] );
			Item->appendSubItem ( 1, TextItem[i], false, NULL );
			Buttons->insertItem ( Item,-1,true );
			h+=Item->height(Buttons);
		}
		connect(Buttons, SIGNAL(selected(int)), this, SLOT(PushButton(int)));
	}
	else if(InstallMode==1)
	{
		chk[0]=false;
		ItemPm[0][0]=r.getIcon("chkbx_mark_indicator_h.g");
		ItemPm[0][1]=r.getIcon("chkbx_mark_indicator_hs.g");
		ZListBoxItem* Item = new ZListBoxItem ( Buttons, "%I%M" );
		Item->setPixmap ( 0, ItemPm[0][chk[0]] );
		Item->appendSubItem ( 1, "Add to OpenWithMenu", false, NULL );
		Buttons->insertItem ( Item,-1,true );
		h+=Item->height(Buttons);
		connect(Buttons, SIGNAL(selected(int)), this, SLOT(PushButton(int)));
	}
	
	panel->moveChild(Buttons,0,b_h);
	
	separator = new ZSeparator(panel, 0, ZSkinService::clsZSeparator1);
	separator->setLength(226);
	panel->moveChild(separator,5,h);
	h+=separator->height();
	
	Label2 = new ZLabel("Install in progress\nPlease wait..", panel, "ZLabel", 0, (ZSkinService::WidgetClsID)4);
	Label2->setFixedWidth(226);
	Label2->setAutoResize( true );
	Label2->setAlignment(Qt::AlignCenter);
	Label2->setFontColor(QColor(50,50,150));
	panel->moveChild(Label2,5,h);
	h+=Label2->heightForWidth(226);
	Label2->setFixedHeight(h);
	Label2->setText("Waiting for continion configuration..");
	
	ProgressBar = new ZMeter(25, 226, panel, "ProgressBar", ZSkinService::clsZMeter_Indicator2);
	panel->moveChild(ProgressBar,5,h);
	h+=ProgressBar->height();
	//ProgressBar->setProgress(3);
	
	Label2->setEnabled(false);
	ProgressBar->setEnabled(false);
}

/*
void keyPressEvent ( QKeyEvent* k )	//keyReleaseEvent
{
	switch(k->key())
	{
		case 0x1038:
			Install();
		break;
		
		case 0x103a:
			qApp->quit();
		break;
		
		default:
		break;
	}
}*/

QString getWorkDir(bool progDir)
{
	QString str =  QString(qApp->argv()[0]);
	int i;
	if(progDir)
		i = str.findRev ( "/" );
	else
		i = str.findRev ( "/plugins" );
	str.remove ( i+1, str.length() - i );
	return str;
}

QString getFileName(QString file_name)
{
	int i = file_name.findRev("/");
	file_name.remove(0, i+1);
	i = file_name.findRev (".");
	if (i==-1)
		file_name;
	else
	{
		file_name.remove(i, file_name.length()-i);
		return file_name;
	}
}

QString getMime(QString file_name)
{
	int i = file_name.findRev (".");
	if (i==-1) return false;
	else return file_name.mid(i+1,file_name.length()-i);
}

QString exec(QString file_name)
{
	int i = file_name.findRev (".");
	if (i==-1) return "exec ";
	else return "sh ";
}

QString SearchFolder(QString destPath) //return Folder
{
	QDir dir ( destPath, "*" );
	dir.setMatchAllDirs ( true );
	dir.setFilter ( QDir::Dirs);
	if ( !dir.isReadable() )
	return 0;
	QStringList entries = dir.entryList();
	return	entries[2];
}

QString SearchIni(QString destPath) //return Folder
{
	QDir file ( destPath, "*.desktop" );
	file.setMatchAllDirs ( true );
	file.setFilter ( QDir::Files);
	if ( !file.isReadable() )
	return 0;
	QStringList entries = file.entryList();
	return	entries[2];
}

QString GenID()
{
	QString uid;
	system("uuidgen > /tmp/installuid_tmp");
	QFile file("/tmp/installuid_tmp");
	if( file.open(IO_ReadOnly) )		
	{
		QTextStream stream( &file );
		stream.setEncoding ( QTextStream::UnicodeUTF8 );
		uid=stream.readLine();
	}
	return uid;
}

int chkPluginId(int app_id)
{
	int new_id=0;bool new_Id=false;
	QFile file(work_folder+"/fm_plugins.cfg");
	if( file.open(IO_ReadOnly) )		
	{
		QTextStream stream( &file );
		QString temp_line;int r_id=0;
		while(temp_line=stream.readLine())
		{
			r_id=atoi(temp_line.mid(0,2));
			if(new_id<r_id)
				new_id=r_id;
			if(app_id==r_id)
			{
				if(Name==temp_line.mid(5,100))
					return -1;
				else
					new_Id=true;
			}
		}
		file.close();
		new_id++;
	}
	if(new_Id)
		return new_id;
	else
		return app_id;
}

bool InstallToReestr(QString desktop_ini) //return RunFile
{
	if(InstallMode==0)
	{
		desktop_ini=desktop_ini+"/"+SearchIni(desktop_ini);
		QString app_id=GenID();bool newapp=true;
		qDebug("Open desktop_ini:"+desktop_ini);
		ZConfig desktop(desktop_ini, true);
		BigIcon=desktop.readEntry("Desktop Entry", "BigIcon", "");
		//Comment=desktop.readEntry("Desktop Entry", "Comment", "");
		Exec=desktop.readEntry("Desktop Entry", "Exec", "");
		if(chk[2])
			GroupID="root";
		else
			GroupID="ezx";
		Icon=desktop.readEntry("Desktop Entry", "Icon", "");
		Name=desktop.readEntry("Desktop Entry", "Name", "");
		Version=desktop.readEntry("Desktop Entry", "Version", "");
		OsVersion=desktop.readEntry("Desktop Entry", "OsVersion", "");
		//Type=desktop.readEntry("Desktop Entry", "Type", "");
		//if(Type=="Application") Type="2";
		desktop.flush();
		if(Name!="" && Name.left(1)!=" ")
		{
			Q_INT32 d;
			QString app_db;
			if(chk[0])
			{
				app_db=CARD_DB;
				d=2;
			}
			if(chk[1])
			{
				app_db=PHONE_DB;
				d=1;
			}
			ZConfig write(app_db, true);
			/*for()
			{
				if(Folder==)
					newapp=false;
			}*/
			if(newapp)
			{
				write.writeEntry(app_id, "AniIcon", "");
				write.writeEntry(app_id, "AppID", QString("{%1}").arg(app_id));
				write.writeEntry(app_id, "Args", "");
				write.writeEntry(app_id, "Attribute", "4");
				write.writeEntry(app_id, "BigIcon", BigIcon);
				write.writeEntry(app_id, "Daemon", "0");
				write.writeEntry(app_id, "Directory", getFileName(Folder));
				write.writeEntry(app_id, "Eraseable", "1");
				write.writeEntry(app_id, "Exec", Exec);
				write.writeEntry(app_id, "FixedAllPosition", "0");
				write.writeEntry(app_id, "FixedPosition", "0");
				write.writeEntry(app_id, "GroupID", GroupID);
				write.writeEntry(app_id, "Icon", Icon);
				write.writeEntry(app_id, "InstalledDate", InstalledDate);
				write.writeEntry(app_id, "JavaId", "-1");
				write.writeEntry(app_id, "MassStorageStatus", "0");
				write.writeEntry(app_id, "MpkgFile", mpkgFile);
				write.writeEntry(app_id, "Name", Name);
				write.writeEntry(app_id, "OsVersion", OsVersion);
				write.writeEntry(app_id, "Shared", "");
				write.writeEntry(app_id, "Size", "!Size");
				write.writeEntry(app_id, "Type", "2");
				write.writeEntry(app_id, "UserID", GroupID);
				write.writeEntry(app_id, "Visible", "1");
				write.flush();
				
				ZConfig main_menu(MENU_DB, true);
				QString items=main_menu.readEntry(MAIN_MENU, "Items", "");
				items+=";"+app_id;
				main_menu.writeEntry(MAIN_MENU, "Items", items);
				main_menu.flush();
				
				QByteArray data;
				QDataStream stream(data, IO_ReadOnly);
				QString folderUid=MAIN_MENU;
				int pos = -1;
				stream << d << app_id << folderUid << pos;
				QCopChannel::send("AM/RegistryiMgr/Channel", "notifyUpdateHomeView");
				QCopChannel::send("AM/RegistryiMgr/Channel", "InstallApp(int, QString, QString, int)", data);
				
				return true;
			}
			else
			{
				if(textView->showText("Installer", "This app already installed - update files in old folder?", "icon.png", 2))
					return true;
				else
					return false;
			}
		}
		else
		{
			return false;
		}
	}
	else if(InstallMode==1)
	{
		desktop_ini+="install.cfg";
		ZConfig desktop(desktop_ini, true);
		Name=desktop.readEntry("Desktop Entry", "Name", "");
		if(Name!="" && Name.left(1)!=" ")
		{
			int app_id, type;
			bool full_p;
			QString install;
			app_id=desktop.readNumEntry("Desktop Entry", "Id", 0);
			Version=desktop.readEntry("Desktop Entry", "Version", "");
			install=desktop.readEntry("Desktop Entry", "InstallCmd", "");
			full_p=desktop.readBoolEntry("Desktop Entry", "FullPath", false);
			type=(!chk[0])*2+full_p;			
			int chkId=chkPluginId(app_id);
			
			if(chkId!=app_id)
			{
				if(chkId==-1)
				{
					if(textView->showText("Installer", "This plugin already installed. Update to this version?", "icon.png", 2))
					{
						textView->showText("Installer", QTDownLoad+getFileName(Folder), "icon.png", 1);
						system(QString("rm -f -r %1").arg(QTDownLoad+getFileName(Folder)));
					}
					else
						return false;
				}
				else
				{
					if(textView->showText("Installer", "Another plugin with this Id already installed. Generate new Id?", "icon.png", 2))
						app_id=chkId;
					else
						return false;
				}
			}
			
			if(chkId!=-1)
			{
				QFile file(work_folder+"/fm_plugins.cfg");
				if (file.open(IO_ReadWrite))
				{
					QString App_id="";
					if(app_id<10)
						App_id="0";
					App_id+=QString::number(app_id);
					QTextStream stream ( &file );
					QString temp_line=stream.read();
					stream.setEncoding ( QTextStream::UnicodeUTF8 );
					QString plug_line=QString("\n%1 %2 %3").arg(App_id).arg(type).arg(Name);
					stream << plug_line;
					file.close();
				}
			}
			if(full_p)
			{
				system(QString("mv %1 %2%3").arg(destPath+Folder).arg(destPath).arg(app_id));
				Folder=QString::number(app_id);
				QTDownLoad+="/full_path";
				QFile file(destPath+Folder+"/desktop.ini");
				if( file.open(IO_ReadOnly) )		
				{
					QTextStream stream( &file );
					Name=stream.readLine();
					file.close();
				}
			}
			
			if(install!="" && install.left(1)!=" ")
				system(exec(install)+desktop_ini+install);
			return true;
		}
		else
			return false;
	}
	return false;
}

public slots:

void Install()
{
	QString UnTgz, Finish;
	
	Label1->setEnabled(false);
	Buttons->setEnabled(false);
	int c=3;
	if(InstallMode==1)
		c=1;
	for(int i=0;i<c;i++)
		Buttons->item(i)->setEnabled(false);
	softKey->setText(ZSoftKey::LEFT, "", (ZSoftKey::TEXT_PRIORITY)0);
	softKey->setText(ZSoftKey::RIGHT, "", (ZSoftKey::TEXT_PRIORITY)0);
	
	//if(chk[2])
	//	Buttons->item(2)->setPixmap ( 0,ItemPmUnEnable[1]);
	if(InstallMode==0)
	{
		if(chk[0])
		{
			QTDownLoad=QString(CARD_PATH);
			//Buttons->item(0)->setPixmap ( 0,ItemPmUnEnable[0]);
		}
		if(chk[1])
		{
			QTDownLoad=QString(PHONE_PATH);
			//Buttons->item(1)->setPixmap ( 0,ItemPmUnEnable[0]);
		}
		destPath=QTDownLoad;
	}
	else if(InstallMode==1)
	{
		destPath=QTDownLoad=work_folder+"/plugins/";
	}
	QDir dir;
	dir.setPath(destPath);
	dir.mkdir("installtmp", false);
	destPath+="installtmp/";
	
	Label2->setEnabled(true);
	Label2->setText("Install in progress\nPlease wait..");
	ProgressBar->setEnabled(true);
	qApp->processEvents();
	
	UnTgz=QString(TGZ_UNCPACK).arg(mpkgFile).arg(destPath);
	//cmd=QString("sleep 20");//
	process=true;
	
	pthread_create( &vis , NULL , visProgress , NULL);
	//pthread_create( &run , NULL , runCmd , NULL);
	system(UnTgz);
	Folder=SearchFolder(destPath);
	if(Folder!="" && Folder.left(1)!=" ")
	{
		if(InstallToReestr(destPath+Folder+"/"))//+Folder+".desktop"
		{
			Finish=QString("mv -f %1 %2").arg(destPath+Folder+"/").arg(QTDownLoad+getFileName(Folder)+"/");
			system(Finish);
			Finish=QString("chmod -R +x %1").arg(QTDownLoad+getFileName(Folder)+"/");
			system(Finish);
			
			process=false;
			
			if(InstallMode==0)
			{
				if(textView->showText("Installer", Name+" "+Version+" install finished! Do you want to run it now?", "icon.png", 2))
					system(exec(Exec)+QTDownLoad+Folder+Exec+"&");
			}
			else if(InstallMode==1)
			{
				textView->showText("Installer", Name+" "+Version+" install finished!", "icon.png", 1);
			}
		}
		else
		{
			Label2->setFontColor(QColor(150,20,20));
			Label2->setText("Cancel installing\nPlease wait..");
			//textView->showText("Installer", "FAIL!\nError of reading "+Folder+".desktop", "icon.png", 1);
			qApp->processEvents();
			system(QString("rm -f -r %1").arg(destPath+Folder+"/"));
			process=false;
			textView->showText("Installer", "FAIL!\nInstall error", "icon.png", 1);
		}
	}
	else
	{
		process=false;
		textView->showText("Installer", "FAIL!\nUnPack error", "icon.png", 1);
	}
	system(QString("rm -f -r %1").arg(destPath));
	qApp->quit();
}

void PushButton(int i)
{
	//int i=Buttons->currentItem();
	//Label2->setText(QString("Current item %1 %2").arg(i).arg(1-i));
	if(i!=2 && !InstallMode)
	{
		chk[i]=true;
		chk[1-i]=false;
		Buttons->item(1-i)->setPixmap(0, ItemPm[i][chk[1-i]]);
	}
	else
	{
		chk[i]=!chk[i];
	}
	Buttons->item(i)->setPixmap(0, ItemPm[i][chk[i]]);
}
};

int main(int argc, char **argv)
{
	ZApplication app(argc, argv);
	Installer* installer = new Installer();
	app.setMainWidget(installer);
	installer->show();
	return app.exec();
}

#include "Installer.moc"
