//
// Author: Strelok Vlad Kolerts, (C) 2009
//
// 

#include "TextView.h"

class TextView;

TextView::TextView() : QWidget(NULL, "TextView")
{
	setBackgroundMode(NoBackground);
	resize( 240, 320 );
	
	ProgDir = getProgramDir ( QString ( qApp->argv() [0] ) );
	///scroll=0;
	
	panel = new QScrollView(this, "TextView", 0);
	panel->setHScrollBarMode(QScrollView::AlwaysOff); 
	panel->setVScrollBarMode(QScrollView::AlwaysOff); //Auto
	panel->setFixedWidth(220);

	Label = new QLabel(this);
	Label->setFixedWidth(220);
	
	softLabel="<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" bgcolor=\"#000000\"><tr>";
	softLabel+="<td align=\"center\" ><font size=\"2\" color=\"#eeeeee\">Yes</font></td>";
	softLabel+="<td align=\"center\" ><font size=\"2\" color=\"#eeeeee\">No</font></td>";
	softLabel+="</tr></table>";
}

bool TextView::showText(QString titl, QString txt, QString icon, int type)
	{
		reply=true;
		question=true;
		QString pm="";
		
		if(icon!=NULL)pm="<img src="+ProgDir+QString("%1 ><br>").arg(icon);
		QString text="<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" bgcolor=\"#000000\"><tr><td align=\"center\" >";
		text+=pm+"<font size=\"3\" color=\"#eeeeee\"><b>"+titl+"</b></font>";
		text+="</td></tr></table><font size=\"3\" color=\"#000000\">";
		if(type==0)	text+=txt+"<br>";
		if(type==1) text+="<p align=\"center\" >"+txt+"</p>";
		if(type==2) 
		{
			text+="<p align=\"center\" >"+txt+"</p>";
			text+=softLabel;
		}
		
		Label->setText(text);
		
		int h=Label->heightForWidth(220);
		Label->setFixedHeight(h);
		
		
		panel->addChild(Label, 0, 0);
		
		if(h<300)
		{
			panel->setFixedHeight(h);
			panel->move(10, (320-h)/2);
		}
		else
		{
			panel->setFixedHeight(300);
			panel->move(10, 10);
		}
		
		show();
		
		while	(question)
		{
			qApp->processEvents();
		}
		
		return reply;
	}


QString TextView::getProgramDir ( const QString &AFileName )
{
  QString str = AFileName;
  int i = str.findRev ( "/" );
  str.remove ( i+1, str.length() - i );
  return str;
}

void TextView::keyPressEvent ( QKeyEvent* k )	//keyReleaseEvent
	{
		switch(k->key())
		{
			case 4115:
				/**scroll--;
				panel->scrollBy(0, scroll);*/
			break;
			case 4117:
				/**scroll++;
				panel->scrollBy(0, scroll);*/
			break;
			case 4116:
			break;
			case 4114:
			break;
			
			case 0x1038:
				if(question)	reply=true;
				question=false;
				hide();
			break;
			
			case 0x103a:
				if(question)	reply=false;
				question=false;
				hide();
			break;
			
			default:
				if(!question)
				{
					hide();
				}
			break;
		}		
	}
